<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyInvoice by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ();

jimport ( 'joomla.application.component.controller' );

class BillControllerBill extends BillController {
	function __construct() {
		parent::__construct ();
		
		$this->registerTask ( 'add', 'edit' );
		$this->registerTask ( 'apply', 'save' );
		$this->registerTask ( 'publish', 'publish' );
		$this->registerTask ( 'unpublish', 'publish' );
	}
	
	function display() {
		JRequest::setVar ( 'view', 'bill' );
		parent::display ();
	}
	
	function returnToList()
	{
	  JRequest::setVar ( 'view', 'bill' );
	  parent::display ();
	}
	
	function accesspublic() {
		$this->changeAccess ( 0 );
	}
	function accessregistered() {
		$this->changeAccess ( 1 );
	}
	function accessspecial() {
		$this->changeAccess ( 2 );
	}
	
	function changeAccess( $access ) {
		global $mainframe;
		$cid = JRequest::getVar ( 'cid', array (0 ), 'post', 'array' );
		$model = $this->getModel ( 'bill' );
		$model->changeAccess ( $cid [0], $access );
		$mainframe->redirect ( 'index.php?option=com_jsbill' );
	}
	
	function publish() {
		JRequest::setVar ( 'view', 'bill' );
		
		$cid = JRequest::getVar ( 'cid', array (), 'post', 'array' );
		$db = & JFactory::getDBO ();
		$ids = implode ( ",", $cid );
		
		if (count ( $ids ) < 1) {
			JError::raiseError ( 500, JText::_ ( 'Select an item to publish' ) );
		}
		
		$published = JRequest::getWord ( 'task', 'publish' ) == 'publish' ? 1 : 0;
		
		$sql = "UPDATE #__bills SET published = " . $published . " WHERE id IN ($ids)";
		$db->setQuery ( $sql );
		$db->query ();
		
		$this->setRedirect ( 'index.php?option=com_jsbill&controller=bill' );
		parent::display ();
	}
	
	function remove() {
		global $mainframe;
		
		JRequest::setVar ( 'view', 'bill' );
		
		$cid = JRequest::getVar ( 'cid', array (), 'post', 'array' );
		$db = & JFactory::getDBO ();
		$ids = implode ( ",", $cid );
		
		if (count ( $ids ) < 1) {
			JError::raiseError ( 500, JText::_ ( 'Select an item to remove' ) );
		}
		
		$sql = "DELETE FROM #__bills WHERE id IN ($ids)";
		$db->setQuery ( $sql );
		$db->query ();
		
		$this->setRedirect ( 'index.php?option=com_jsbill&controller=bill' );
		parent::display ();
	}
	
	function edit() {
		JRequest::setVar ( 'view', 'bill' );
		JRequest::setVar ( 'layout', 'form' );
		parent::display ();
	}
	
	function save() 
	{
		$dispatcher =& JDispatcher::getInstance();
		JRequest::setVar ( 'view', 'bill' );
		
		$post = JRequest::get ( 'post' );
		$cid = JRequest::getVar ( 'cid', array (0 ), 'post', 'array' );
		$post ['id'] = ( int ) $cid [0];
		
		$model = $this->getModel ( 'bill', 'BillModel' );
		
		if ( $model->store ( $post ) ) {
			$msg = JText::_ ( 'Bill Saved' );
		} else {
			$msg = JText::_ ( 'Error Saving Bill' ) . '<br>' . $model->getError ();
		}
		
		$model->checkin();
		
		$registry = new JRegistry();
		$registry->loadArray($post['params']);	
		$plugin_params  = $registry->toString();
		$plugin_params = new JParameter($plugin_params);
		JPluginHelper::importPlugin('bill_gateways');
		$dispatcher->trigger('onCheckParams', array( $plugin_params ) );
		
		$link = 'index.php?option=com_jsbill&controller=bill';
		if (JRequest::getWord ( 'task' ) == 'apply' || count(JError::getErrors()) )
			$link = 'index.php?option=com_jsbill&controller=bill&task=edit&cid[]=' . $model->id;
		$this->setRedirect ( $link, $msg );
		parent::display ();
	}
	
	function alertbill()
	{
	  JRequest::setVar ( 'view',   'alertbill' );
    JRequest::setVar ( 'layout', 'default' );
	 
    parent::display ();
	}
}
?>
