<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyInvoice by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ( 'dead' );

jimport ( 'joomla.application.component.model' );

class BillModelBill extends JModel {
	var $_data = null;
	var $_total = null;
	var $_pagination = null;
	var $_id = null;
	function __construct() {
		parent::__construct ();

		global $mainframe, $option;

		$limit = $mainframe->getUserStateFromRequest ( 'global.list.limit', 'limit', $mainframe->getCfg ( 'list_limit' ), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest ( $option . 'coupon.limitstart', 'limitstart', 0, 'int' );

		$this->setState ( 'limit', $limit );
		$this->setState ( 'limitstart', $limitstart );

		$array = JRequest::getVar ( 'cid', array (0 ), '', 'array' );
		$this->setId ( ( int ) $array [0] );
	}

	function changeAccess($uid, $access) {
		$bill = $this->getTable ( 'bill' );
		$bill->load ( $uid );
		$bill->access = $access;

		if (! $bill->check ()) {
			return $bill->getError ();
		}
		if (! $bill->store ()) {
			return $bill->getError ();
		}
	}

	function getNextNum($row) {
		$select = "SELECT COUNT(*) FROM #__bills_invoice where published = 1 ";
		//$select .= "AND order_num = '{$row->order_num}'";
		$select .= "AND coption = '{$row->coption}'";
		$select .= "AND client = '{$row->client}'";
		$select .= "AND seller_id = '{$row->seller_id}'";
		$this->_db->setQuery ( $select );
		$number = $this->_db->loadResult () + 1 + BILL_INV_NUM;
		return sprintf ( '%0' . BILL_INV_DIG . 'd', $number );

	}
	function bill_price($cur, $amount) {
		return str_replace ( array ('00', 'Sign' ), array ($cur, number_format ( $amount, 2 ) ), BILL_PRICE );
	}
	function getInvoice($i_id) {
		$sql = "SELECT * , LPAD( `inv_num`, " . BILL_INV_DIG . ", 0 ) AS inv_num, DATE_FORMAT(ctime,'%e %M %Y') as format_ctime FROM #__bills_invoice WHERE id = $i_id ";
		$this->_db->setQuery ( $sql );
		$row = $this->_db->loadObject ();

		$this->_id = @$row->bill_id;
		return $row;
	}

	function setId($id) {
		$this->_id = $id;
		$this->_data = null;
		$this->_plan = null;
	}
	function getPayments() {
		$sql = "SELECT * FROM #__plugins WHERE folder = 'bill_gateways' AND published = 1";
		return $this->_getList ( $sql );
	}

	function getBill() {
		if ($this->_plan == null) {
			if ($this->_id) {
				$query = 'SELECT * , DATE_FORMAT(ctime,"%e %M %Y") as format_ctime FROM #__bills WHERE id = ' . ( int ) $this->_id;
				$this->_db->setQuery ( $query );
				$this->_plan = $this->_db->loadObject ();
				return $this->_plan;
			} else {
				return $this->initData ();
			}
		}
		return $this->initData ();
	}

	function initData() {
		$plan = new stdClass ( );
		$plan->id = null;
		$plan->user_id = 0;
		$plan->use_user = 0;
		$plan->params = '';
		$plan->published = 1;
		$plan->extime = null;
		$plan->ctime = strftime ( '%Y-%m-%d %H:%M:%S', time () );
		$plan->access = 1;
		$plan->product_list = '';
		$plan->use_num = 0;
		$plan->used_num = 0;
		$plan->use_user = 0;
		$plan->order_num = '';
		$this->_plan = $plan;
		return $plan;
	}
	
	function store( $data ) {
		$row = & $this->getTable ();
        $user = & JFactory::getUser();
		
		if( !is_array( $data ['product_list'] ) ) {
			$data ['product_list'] = unserialize( $data ['product_list'] );
		}

		$products_count = 0;
		for ( $i = 1; $i <= 10000; $i++ ) {
			if( $data['product_list'][1]['title'] ) {
				$products_count ++;
				if( !($data['product_list'][1]['qnt'] * $data['product_list'][1]['amount']) ) {
					$this->setError ( JText::_( "Cannot Store. Order price is null" ) );
			        return false;
				}
			} else {
				break;
			}
		}

		if( $products_count == 0 ) {
			$this->setError (  JText::_( "Cannot Store. Products is not set" ) );
			return false;
		}

		$data ['product_list'] = serialize ( $data ['product_list'] );

		if( !$data['order_num'] ) {
			$this->setError (  JText::_( "Cannot Store. Order number must be set" ) );
			return false;
		}
			
		if ( ! $row->bind ( $data ) ) {
			$this->setError ( $this->_db->getErrorMsg () );
			//echo "1111"; exit;
			return false;
		}

		if( !$row->get( "seller_id" ) ) {
			$row->set( "seller_id", $user->get( "id" ) );
		}
		
		if ( ! $row->check () ) {
			$this->setError ( JText::_( 'Check fail' ). $row->_error );
			//echo "1111"; exit;
			return false;
		}

		if ( ! $row->store () ) {
			$this->setError ( JText::_( 'Cannot Store' ). $row->getError () );
			return false;
		}
		$this->id = $row->id;
		return true;
	}
	
	function checkin() {
		if ($this->_id) {
			$coupon = & $this->getTable ();
			if (! $coupon->checkin ( $this->_id )) {
				$this->setError ( $this->_db->getErrorMsg () );
				return false;
			}
		}
		return false;
	}

	function getData() {
		if (empty ( $this->_data )) {
			$query = $this->_buildQuery ();
			$this->_data = $this->_getList ( $query, $this->getState ( 'limitstart' ), $this->getState ( 'limit' ) );
		}

		return $this->_data;
	}
	function _buildQuery() {
		$where = $this->_buildContentWhere ();
		$orderby = $this->_buildContentOrderBy ();

		$query = '
		SELECT p.*, , LPAD( p.`inv_num`, ' . BILL_INV_DIG . ', 0 ) AS inv_num, b.amount , b.item_name , u.name AS uname, u.email, u.id AS uid,
		       DATE_FORMAT(p.ctime, \'%d, %b %Y\') AS ctime, 
              b.id AS pid  ' . ' FROM #__bills_invoice AS p ' . ' LEFT JOIN #__users AS u ON u.id = p.user_id ' . ' LEFT JOIN #__bills AS b ON p.bill_id = b.id ' . $where . $orderby;
		return $query;

	}
	function _buildContentOrderBy() {
		global $mainframe, $option;

		$filter_order = $mainframe->getUserStateFromRequest ( $option . 'users.filter_order', 'filter_order', 'p.ctime', 'cmd' );
		$filter_order_Dir = $mainframe->getUserStateFromRequest ( $option . 'users.filter_order_Dir', 'filter_order_Dir', 'DESC', 'word' );

		$orderby = ' ORDER BY ' . $filter_order . ' ' . $filter_order_Dir . '';

		return $orderby;
	}
	function _buildContentWhere() {
		global $mainframe, $option;

		$filter_state = $mainframe->getUserStateFromRequest ( $option . 'users.filter_state', 'filter_state', '', 'word' );
		$filter_plans = $mainframe->getUserStateFromRequest ( $option . 'users.users.filter_plans', 'subscription_id', 0, 'int' );
		$filter_order = $mainframe->getUserStateFromRequest ( $option . 'users.filter_order', 'filter_order', 'a.ordering', 'cmd' );
		//$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'users.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search = $mainframe->getUserStateFromRequest ( $option . 'users.search', 'search', '', 'string' );
		$search = JString::strtolower ( $search );

		$where = array ();

		if ($filter_plans > 0) {
			$where [] = 'p.id = ' . ( int ) $filter_plans;
		}
		if ($search) {
			$w = ' (LOWER(b.name) LIKE ' . $this->_db->Quote ( '%' . $search . '%' );
			$w .= ' OR LOWER(p.gateway) LIKE ' . $this->_db->Quote ( '%' . $search . '%' );
			$w .= ' OR LOWER(p.gateway_id) LIKE ' . $this->_db->Quote ( '%' . $search . '%' );
			$w .= ' )';
			$where [] = $w;
		}
		//$where[] = 'p.published = 1';


		//JUser conditions
		if (JRequest::getVar ( 'no_html', 0 )) {

			$ju_cid = JRequest::getVar ( 'ju_cid', array () );

			if (is_array ( $ju_cid ) && count ( $ju_cid )) {
				$where [] = ' u.id IN (' . implode ( ' , ', $ju_cid ) . ') ';
			}

		} //JUser conditions (end)


		$where = (count ( $where ) ? ' WHERE ' . implode ( ' AND ', $where ) : '');

		return $where;
	}
	function getTotal() {
		if (empty ( $this->_total )) {
			$query = $this->_buildQuery ();
			$this->_total = $this->_getListCount ( $query );
		}

		return $this->_total;
	}
	function getPagination() {
		if (empty ( $this->_pagination )) {
			jimport ( 'joomla.html.pagination' );
			$this->_pagination = new JPagination ( $this->getTotal (), $this->getState ( 'limitstart' ), $this->getState ( 'limit' ) );
		}

		return $this->_pagination;
	}
	function getUsers($default) {
		$query = "SELECT id, name, username FROM `#__users` where `block` = 0";
		$this->_db->setQuery ( $query );
		$static = $this->_db->loadObjectList ();
		$stscontent [] = JHTML::_ ( 'select.option', '', '- Select User -', 'id', 'name' );
		foreach ( $static as $stat ) {
			$stscontent [] = JHTML::_ ( 'select.option', $stat->id, "(ID: $stat->id)  $stat->name [$stat->username]", 'id', 'name' );
		}
		return JHTML::_ ( 'select.genericlist', $stscontent, 'user_id', ' class="inputbox"', 'id', 'name', $default );

	}
	function publish($cid = array(), $publish = 1) {

		$invoice = JTable::getInstance ( 'Invoice', 'Table' );

		foreach ( $cid as $id ) {
			$invoice->load ( $id );

			if ($invoice->published == 1)
			continue;

			$inv_num = $this->getNextNum ( $invoice );

			$inv_num = sprintf ( '%0' . BILL_INV_DIG . 'd', $inv_num );

			$invoice->published = ( int ) $publish;
			$invoice->inv_num = $inv_num;

			/*$query = 'UPDATE #__bills_invoice'
				. ' SET published = '.(int) $publish
				. ', inv_num = "'. $inv_num .'"'
				. ' WHERE id IN ( '.$id.' )'
				;
				$this->_db->setQuery( $query );*/
			if (! $invoice->store ()) {
				$this->setError ( $invoice->getError () );
				return false;
			}
			//$inv_num = $inv_num + 1;
		}

		return true;
	}
	function checkout($uid = null) {
		if ($this->_id) {
			// Make sure we have a user id to checkout the article with
			if (is_null ( $uid )) {
				$user = & JFactory::getUser ();
				$uid = $user->get ( 'id' );
			}
			// Lets get to it and checkout the thing...
			$weblink = & $this->getTable ();
			if (! $weblink->checkout ( $uid, $this->_id )) {
				$this->setError ( $this->_db->getErrorMsg () );
				return false;
			}

			return true;
		}
		return false;
	}
	function isCheckedOut($uid = 0) {
		if ($this->_loadData ()) {
			if ($uid) {
				return ($this->_data->checked_out && $this->_data->checked_out != $uid);
			} else {
				return $this->_data->checked_out;
			}
		}
	}

	function delete($cid = array()) {
		$result = false;

		if (count ( $cid )) {
			JArrayHelper::toInteger ( $cid );
			$cids = implode ( ',', $cid );
			$query = 'DELETE FROM #__bills_invoice' . ' WHERE id IN ( ' . $cids . ' ) AND published = 0';
			$this->_db->setQuery ( $query );
			if (! $this->_db->query ()) {
				$this->setError ( $this->_db->getErrorMsg () );
				return false;
			}
		}

		return true;
	}
	function _plaginPayList($payparams)
	{
		$query = "SELECT * FROM #__plugins WHERE folder LIKE 'payment'";
		$this->_db->setQuery( $query );
		$plagins = $this->_db->loadObjectList();

		$pane		=& JPane::getInstance('sliders');
		$out =  $pane->startPane("content-pane");


		foreach ($plagins as $plagin) {
			$out .= $pane->startPanel( $plagin->name, 'cpanel-panel-'.$plagin->name );

			if($payparams)
			{
				$params  = new JParameter($payparams, JApplicationHelper::getPath( 'plg_xml', $plagin->folder.DS.$plagin->element ), 'plugin' );
			}
			else
			{
				$params = new JParameter($plagin->params, JApplicationHelper::getPath( 'plg_xml', $plagin->folder.DS.$plagin->element ), 'plugin' );
			}

			$out .= $params->render('params');

			$out .= $pane->endPanel();
		}

		$out .= $pane->endPane();
		return $out;

	}

}
?>
