<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyInvoice by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('dead');

jimport('joomla.application.component.model');

class BillModelBills extends JModel
{
	var $_data = null;
	var $_total = null;
	var $_pagination = null;
	var $_id = null;
	function __construct()
	{
		parent::__construct();

		global $mainframe, $option;

		$limit      = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'coupon.limitstart', 'limitstart', 0, 'int' );

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}
  
	function getNextNum( $row )
  {
    $select = "SELECT COUNT(*) FROM #__bills_invoice where published = 1 ";
    //$select .= "AND order_num = '{$row->order_num}'";
    $select .= "AND coption = '{$row->coption}'";
    $select .= "AND client = '{$row->client}'";
    $select .= "AND seller_id = '{$row->seller_id}'";   
    $this->_db->setQuery($select);
    $number = $this->_db->loadResult() + 1 + BILL_INV_NUM;
    return sprintf('%0'.BILL_INV_DIG.'d', $number);
  }

	function bill_price($cur, $amount)
	{
		return str_replace(array('00','Sign'), array($cur, number_format($amount,2)), BILL_PRICE );
	}

	function getInvoice($i_id)
	{
		$sql = "SELECT *, LPAD( `inv_num`, ".BILL_INV_DIG.", 0 ) AS inv_num , DATE_FORMAT(ctime,'%e %M %Y') as format_ctime FROM #__bills_invoice WHERE id = $i_id ";
		$this->_db->setQuery($sql);
		$row = $this->_db->loadObject();

		$this->_id = @$row->bill_id;
		return $row;
	}

	function setId($id)
	{
		$this->_id		= $id;
		$this->_data	= null;
		$this->_plan	= null;
	}

	function initData()
	{
		$plan = new stdClass();
		
		$plan->id = null;
		$plan->user_id = 0;
		$plan->ctime  = strftime('%Y-%m-%d %H:%M:%S', time());
		$plan->gateway   = '';
		$plan->gateway_id   = 0;
		$plan->published   = 0;
		$plan->order_num  = 0;
		$plan->inv_num  = 0;
		$plan->name	= '';
		$plan->seller_id = 0;
		$plan->total = 0;
		$plan->client = '';
		$plan->coption = '';
		$plan->params = '';

		$this->_plan = $plan;
		return $this->_plan;


	}
	function store($data)
	{
		$row =& $this->getTable();


		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			//echo "1111"; exit;
			return false;
		}

		if (!$row->check()) {
			$this->setError('Check fail'. $row->_error);
			//echo "1111"; exit;
			return false;
		}

		if (!$row->store()) {
			$this->setError('Cannot Store'. $row->getError());
			return false;
		}
		$this->id = $row->id;
		return true;
	}
	function checkin()
	{
		if ($this->_id)
		{
			$coupon = & $this->getTable();
			if(! $coupon->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}



	function getData()
	{
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}
	function _buildQuery()
	{
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();

		$query = '
		SELECT p.*, LPAD( `inv_num`, '.BILL_INV_DIG.', 0 ) AS inv_num, u.name AS uname, u.email, u.id AS uid,
		       DATE_FORMAT(p.ctime, \'%d, %b %Y\') AS ctime '
		. ' FROM #__bills_invoice AS p '
		. ' LEFT JOIN #__users AS u ON u.id = p.user_id '
		. $where
		. $orderby
		;
		//print $query;
		return $query;
	}
	function _buildContentOrderBy()
	{
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'users.filter_order',		'filter_order',		'p.ctime',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'users.filter_order_Dir',	'filter_order_Dir',	'DESC',				'word' );

		if( ! $filter_order || ! $filter_order_Dir ) {
			$filter_order = 'p.ctime';
			$filter_order_Dir = 'DESC';
		}
		
		$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.'';

		return $orderby;
	}
	function _buildContentWhere()
	{
		global $mainframe, $option;

		$filter_state		= $mainframe->getUserStateFromRequest( $option.'users.filter_state',		'filter_state',		'',				'word' );
		$filter_plans		= $mainframe->getUserStateFromRequest( $option.'users.users.filter_plans',		'subscription_id',		0,	'int' );
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'users.filter_order',		'filter_order',		'a.ordering',	'cmd' );
		//$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'users.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'users.search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );

		$where = array();

		if ($filter_plans > 0) {
			$where[] = 'p.id = '.(int) $filter_plans;
		}
		if ($search) {
			$w  = ' (LOWER(p.name) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w .= ' OR LOWER(p.gateway) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w .= ' OR LOWER(p.gateway_id) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w .= ' )';
			$where[] = $w;
		}
		//$where[] = 'p.published = 1';


		//JUser conditions
		if( JRequest::getVar('no_html', 0 ) ){

			$ju_cid = JRequest::getVar('ju_cid', array() );

			if( is_array($ju_cid) && count($ju_cid) ){
				$where[] = ' u.id IN ('.implode( ' , ', $ju_cid ).') ';
			}

		}//JUser conditions (end)


		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}
	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}
	function getPagination()
	{

		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}

	function publish($cid = array(), $publish = 1)
	{

		$invoice = JTable::getInstance( 'Invoice', 'Table' );
    
	    foreach ( $cid as $id ) {
	      $invoice->load( $id );
	      
	      if( $invoice->published == 1 ) continue;
	      
	      $inv_num = $this->getNextNum( $invoice );
	      
	      $inv_num = sprintf('%0'.BILL_INV_DIG.'d', $inv_num);
	      
	      $invoice->published = (int) $publish;
	      $invoice->inv_num = $inv_num;
	      
	      /*$query = 'UPDATE #__bills_invoice'
	        . ' SET published = '.(int) $publish 
	        . ', inv_num = "'. $inv_num .'"'
	        . ' WHERE id IN ( '.$id.' )'
	      ;
	      $this->_db->setQuery( $query );*/
	      if ( !$invoice->store() ) {
	        $this->setError( $invoice->getError() );
	        return false;
	      }
	      $inv_num = $inv_num + 1 ;
	    }
	
	    return true;
	}
	
	function checkout($uid = null)
	{
		if ($this->_id)
		{
			// Make sure we have a user id to checkout the article with
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			// Lets get to it and checkout the thing...
			$weblink = & $this->getTable();
			if(!$weblink->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}
		return false;
	}
	function isCheckedOut( $uid=0 )
	{
		if ($this->_loadData())
		{
			if ($uid) {
				return ($this->_data->checked_out && $this->_data->checked_out != $uid);
			} else {
				return $this->_data->checked_out;
			}
		}
	}


	function delete($cid = array())
	{
		$result = false;

		if (count( $cid ))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'DELETE FROM #__bills_invoice'
			. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if(!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}



}
?>   
