<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyInvoice by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ();

jimport ( 'joomla.application.component.view' );

class BillViewBill extends JView {
	function display($tpl = null) {
		global $mainframe, $TB, $Itemid;

		if ($this->getLayout () == 'form') {
			$this->_form ( $tpl );
			return;
		}

		if ($this->getLayout () == 'about') {
			$file = JPATH_COMPONENT_ADMINISTRATOR . DS . 'com_jsbill.xml';
			$file2 = JPATH_COMPONENT_ADMINISTRATOR . DS . 'update_com_jsbill.xml';
			if (JFile::exists ( $file2 ))
			$file = $file2;
				
			$data = JApplicationHelper::parseXMLInstallFile ( $file );
			$this->assignRef ( 'data', $data );
				
			parent::display ();
			return;
		}

		@JToolBarHelper::title ( JText::_ ( 'Bills' ), 'generic.png' );
		@JToolBarHelper::custom( "alertbill", "send.png", "send.png", "Alert bill" );
		@JToolBarHelper::publishList ();
		@JToolBarHelper::unpublishList ();
		@JToolBarHelper::deleteList ();
		@JToolBarHelper::editListX ();
		@JToolBarHelper::addNewX ();
	  

		JHTML::_ ( 'behavior.tooltip' );
		JHTML::_ ( 'behavior.calendar' );
		$db = & JFactory::getDBO ();
		$user = & JFactory::getUser ();
		$option = JRequest::getVar ( 'option', 'com_jsbill' );

		$filter_order = $mainframe->getUserStateFromRequest ( "{$option}.view_bill.filter_order", 'filter_order', 'c.ctime' );
		$filter_order_Dir = $mainframe->getUserStateFromRequest ( "{$option}.view_bill.filter_order_Dir", 'filter_order_Dir', 'DESC' );
		$limit = $mainframe->getUserStateFromRequest ( "{$option}.view_bill.limit", 'limit', $mainframe->getCfg ( 'list_limit' ), 0 );
		$limitstart = JRequest::getVar ( 'limitstart', 0, '', 'int' );
		$filter_state = $mainframe->getUserStateFromRequest ( $option . '.bill.filter_state', 'filter_state', '', 'word' );
		$filter_search = $mainframe->getUserStateFromRequest ( $option . '.bill.filter_search', 'filter_search', '', 'string' );
		$filter_filter1 = $mainframe->getUserStateFromRequest ( $option . '.bill.filter_filter1', 'filter_filter1', '', 'int' );
		$filter_filter2 = $mainframe->getUserStateFromRequest ( $option . '.bill.filter_filter2', 'filter_filter2', '', 'int' );
		$filter_filter3 = $mainframe->getUserStateFromRequest ( $option . '.bill.filter_filter3', 'filter_filter3', '', 'string' );

		if ($filter_order)
		$orderby = "\n ORDER BY $filter_order $filter_order_Dir";

		$where = array ();
		if ($filter_search) {
			$w [] = "c.product_list LIKE '%{$filter_search}%'";
			$w [] = "c.id = '{$filter_search}'";
			$where [] = "(" . implode ( ' OR ', $w ) . ")";
		}

		if ( $filter_filter3 ) {
			$where [] = "client = '".$db->getEscaped( $filter_filter3 )."'";
		}

		if ($filter_filter1 == 1) {
			$where [] = "user_id = 0";
		}

		if ($filter_filter1 == 2) {
			$where [] = "user_id > 0";
		}

		if ($filter_filter2 == 1) {
			$where [] = "extime < NOW()";
		}
		if ($filter_filter2 == 2) {
			$where [] = "extime > NOW()";
			$where [] = "ctime < NOW()";
		}
		if ($filter_filter2 == 4) {
			$where [] = "used_num = 0";
		}
		if (count ( $where ) > 0) {
			$where = ' WHERE ' . implode ( ' AND ', $where );
		} else {
			$where = '';
		}

		$query = "SELECT COUNT(*)" . "\n FROM #__bills ";

		$db->setQuery ( $query );
		$total = $db->loadResult ();

		jimport ( 'joomla.html.pagination' );
		$pageNav = new JPagination ( $total, $limitstart, $limit );

		$query =   " SELECT c.*, g.name as groupname, " . "DATE_FORMAT(c.ctime, '%d, %b %Y') AS `start`, " . "DATE_FORMAT(c.extime, '%d, %b %Y') AS `finish`, " . "IF(c.extime < NOW(),1,0) AS expire " 
		       . "\n   FROM #__bills AS c " 
		       . 'LEFT JOIN #__groups AS g ON g.id = c.access '.
		       $where . $orderby;
		$db->setQuery ( $query, $pageNav->limitstart, $pageNav->limit );
		//echo $db->_sql;
		$rows = $db->loadObjectList ();

		$lists ['order']     = $filter_order;
		$lists ['order_Dir'] = $filter_order_Dir;

		$lists ['search'] = $filter_search;
		$lists ['state'] = JHTML::_ ( 'grid.state', $filter_state );
		$types [] = JHTML::_ ( 'select.option', '', JText::_ ( '- Type -' ) );
		$types [] = JHTML::_ ( 'select.option', '1', JText::_ ( 'Anybody' ) );
		$types [] = JHTML::_ ( 'select.option', '2', JText::_ ( 'Personal' ) );
		$lists ['filter1'] = JHTML::_ ( 'select.genericlist', $types, 'filter_filter1', 'class="inputbox" onchange="document.adminForm.submit();"', 'value', 'text', $filter_filter1 );

		$t [] = JHTML::_ ( 'select.option', '', JText::_ ( '- Activity -' ) );
		$t [] = JHTML::_ ( 'select.option', '1', JText::_ ( 'Expired' ) );
		$t [] = JHTML::_ ( 'select.option', '2', JText::_ ( 'Valid' ) );
		$t [] = JHTML::_ ( 'select.option', '3', JText::_ ( 'Used out' ) );
		$t [] = JHTML::_ ( 'select.option', '4', JText::_ ( 'Never Paid' ) );
		$lists ['filter2'] = JHTML::_ ( 'select.genericlist', $t, 'filter_filter2', 'class="inputbox" onchange="document.adminForm.submit();"', 'value', 'text', $filter_filter2 );

		$v [] = JHTML::_ ( 'select.option', '', JText::_ ( '- Select Client -' ) );
		$db->setQuery ( "select concat(client, ' (', count(*), ')') as text, client as value  from #__bills group by client order by client" );
		$v = array_merge( $v, $db->loadObjectList() );
		$lists ['filter3'] = JHTML::_ ( 'select.genericlist', $v, 'filter_filter3', 'class="inputbox" onchange="document.adminForm.submit();"', 'value', 'text', $filter_filter3 );

		$this->assignRef ( 'lists', $lists );
		$this->assignRef ( 'rows', $rows );
		$this->assignRef ( 'pageNav', $pageNav );
		parent::display ( $tpl );
	}
	
	function _form($tpl = null)
	{
		global $mainframe, $option;

		jimport ( 'joomla.html.pane' );
		
		$db   = & JFactory::getDBO ();
		$uri  = & JFactory::getURI ();
		$user = & JFactory::getUser ();
		$pane = & JPane::getInstance ( 'sliders' );

		JHTML::_ ( 'behavior.tooltip' );
		JHTML::_ ( 'behavior.calendar' );

		$row = $this->get ( 'Bill' );

		$isNew = ($row->id < 1);

		$text = $isNew ? JText::_ ( 'New' ) : JText::_ ( 'Edit' );
		JToolBarHelper::title ( JText::_ ( 'Bill' ) . ': <small><small>[ ' . $text . ' ]</small></small>' );
		JToolBarHelper::save ();
		JToolBarHelper::apply ();
		if ($isNew) {
			JToolBarHelper::cancel ();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel ( 'cancel', 'Close' );
		}
		//JFile::read(JPATH_COMPONENT_ADMINISTRATOR.DS.'config.ini')
		$prm = new JParameter ( $row->params, JPATH_COMPONENT_ADMINISTRATOR . DS . 'params.xml' );
		$prm->def ( 'curr',        BILL_CURR );
		$prm->def ( 'tax',         BILL_TAX );
		$prm->def ( 'tax_name',    BILL_TAX_NAME );
		$prm->def ( 'show_personal_taxid', BILL_SHOW_PERSONAL_TAXID );
		$prm->def ( 'tax_chose',   BILL_TAX_CHOSE );
		//$prm->def('qnt_change', BILL_QNT_CHANGE);
		$prm->def ( 'price',       BILL_PRICE );
		$prm->def ( 'inv_person',  BILL_INV_PERSON );
		$prm->def ( 'inv_name',    BILL_INV_NAME );
		$prm->def ( 'inv_address', BILL_INV_ADDRESS );
		$prm->def ( 'inv_country', BILL_INV_COUNTRY );
		$prm->def ( 'inv_state',   BILL_INV_STATE );
		$prm->def ( 'inv_zip',     BILL_INV_ZIP );
		$prm->def ( 'inv_tel',     BILL_INV_TEL );
		$prm->def ( 'inv_fax',     BILL_INV_FAX );
		$prm->def ( 'inv_tel2',    BILL_INV_ADD );
		$prm->def ( 'inv_logo',    BILL_INV_LOGO );
		$prm->def ( 'inv_city',    BILL_INV_CITY );
		$prm->def ( 'inv_number',  BILL_INV_NUMBER );
		$prm->def ( 'inv_tax_id',  BILL_INV_TAX_ID );
		$prm->def ( 'owner_alert', BILL_OWNER_ALERT );
		$prm->def ( 'super_alert', BILL_SUPER_ALERT );
		$prm->def ( 'mails_alert', BILL_MAILS_ALERT );
		
		$prm->def ( 'billto_name',     BILL_BILLTO_NAME );
		$prm->def ( 'billto_address',  BILL_BILLTO_ADDRESS );
		$prm->def ( 'billto_city',     BILL_BILLTO_CITY );
		$prm->def ( 'billto_state',    BILL_BILLTO_STATE );
		$prm->def ( 'billto_zip',      BILL_BILLTO_ZIP );
		$prm->def ( 'billto_country',  BILL_BILLTO_COUNTRY );
		$prm->def ( 'billto_tel',      BILL_BILLTO_TEL );
		$prm->def ( 'shipto_name',     BILL_SHIPTO_NAME );
		$prm->def ( 'shipto_address',  BILL_SHIPTO_ADDRESS );
		$prm->def ( 'shipto_city',     BILL_SHIPTO_CITY );
		$prm->def ( 'shipto_state',    BILL_SHIPTO_STATE );
		$prm->def ( 'shipto_zip',      BILL_SHIPTO_ZIP );
		$prm->def ( 'shipto_country',  BILL_SHIPTO_COUNTRY );
		$prm->def ( 'shipto_tel',      BILL_SHIPTO_TEL );

		$prm->def ( 'seller_alert_itemid', BILL_SELLER_ALERT_ITEMID );
		$prm->def ( 'byer_alert_itemid', BILL_BYER_ALERT_ITEMID );
		
		$lists ['published'] = JHTML::_ ( 'select.booleanlist', 'published', 'class="inputbox"', $row->published );
		$lists ['access'] = JHTML::_ ( 'list.accesslevel', $row );

		$lists ['ctime'] = JHTML::_ ( 'calendar', $row->ctime ? $row->ctime : 'Never', 'ctime', 'ctime', '%Y-%m-%d %H:%M:%S', array ('class' => 'inputbox' ) );
		$lists ['extime'] = JHTML::_ ( 'calendar', $row->extime ? $row->extime : 'Never', 'extime', 'extime', '%Y-%m-%d %H:%M:%S', array ('class' => 'inputbox' ) );

		$lists ['payments'] = $this->get ( 'Payments' );
		$lists ['user_id'] = $this->getUser ( $row->user_id, 'user_id' );

		$this->assignRef ( 'lists', $lists );
		$this->assignRef ( 'prm', $prm );
		$this->assignRef ( 'row', $row );
		$this->assignRef ( 'pane', $pane );
		$this->assignRef ( 'isNew', $isNew );
		parent::display ( $tpl );
	}
	function getUser($value, $control_name) {
		global $mainframe;

		$db = & JFactory::getDBO ();
		$doc = & JFactory::getDocument ();
		$template = $mainframe->getTemplate ();

		$user = & JTable::getInstance ( 'user' );

		if ($value) {
			$user->load ( $value );
		} else {
			$user->title = JText::_ ( 'Select an User' );
		}

		$js = "
		function jSelectArticle(id, name) {
			document.getElementById('user_id').value = id;
			document.getElementById('user_name').value = name;
			document.getElementById('sbox-window').close();
		}";
		$doc->addScriptDeclaration ( $js );

		$link = 'index.php?option=com_jsbill&amp;task=element&amp;tmpl=component';

		JHTML::_ ( 'behavior.modal', 'a.modal' );

		$html = "\n" . '<div style="float: left;">
		<input style="background: #ffffff;" type="text" id="user_name" value="' . htmlspecialchars ( $user->name, ENT_QUOTES, 'UTF-8' ) . '" disabled="disabled" /></div>';
		$html .= '<div class="button2-left"><div class="blank"><a class="modal" title="' . JText::_ ( 'Select an Article' ) . '"  href="' . $link . '" rel="{handler: \'iframe\', size: {x: 550, y: 500}}">' . JText::_ ( 'Select' ) . '</a></div></div>' . "\n";
		$html .= '<div class="button2-left"><div class="blank"><a title="' . JText::_ ( 'Clear User' ) . '"  onclick="jSelectArticle(0, \'Any\')">' . JText::_ ( 'Clear' ) . '</a></div></div>' . "\n";
		$html .= "\n" . '<input type="hidden" id="user_id" name="' . $control_name . '" value="' . $value . '" />';

		return $html;
	}
}
?>
