<?php
/**
 * $Id: controller.php 7784 2012-02-09 09:44:09Z alfiya $
 * $LastChangedDate: 2012-02-09 15:44:09 +0600 (Thu, 09 Feb 2012) $
 * $LastChangedBy: alfiya $
 * MightyInvoice by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class BillController extends JController
{
	function display()
	{
		global $mainframe;

		if ( !JRequest::getVar('layout' ) && !JRequest::getVar('view' ) && !JRequest::getInt('bill' ) && !JRequest::getVar( 'order_number' ) ) {
			$mainframe->redirect( 'index.php?option=com_jsbill&view=bill&layout=history'.JRequest::getInt( 'Itemid' ) );
		}

		if( !in_array( JRequest::getVar( 'view' ), array( "personalbills", "mysellings" ) ) ) {
			JRequest::setVar('view', 'bill' );
		}

		parent::display();
	}

	function return_success()
	{
		global $mainframe;
		$id = JRequest::getInt('id');
		$db  = & JFactory::getDBO();

		$db->setQuery('SELECT *, LPAD( `inv_num`, '.BILL_INV_DIG.', 0 ) AS inv_num FROM #__bills_invoice WHERE id='.$id);
		$invoice = $db->loadObject();

		$db->setQuery('SELECT return_success FROM #__bills WHERE id='.$invoice->bill_id);
		$url = $db->loadResult();

		$url = str_replace(array('%3D','%26','%3F'),array('=','&','?'),$url);
		$url .= '&user_id='.$invoice->user_id.'&price='.$invoice->price.'&gateway=paybill&gateway_id='.$invoice->gateway_id;

		if(substr($url,0,5) == 'index'){
			$mainframe->redirect($url);
		}
		header('Location: '.$url);
	}

	function pay()
	{
		global $mainframe;

		$db   = & JFactory::getDBO();
		$user = & JFactory::getUser();

		$datenow = & JFactory::getDate();

		$model = $this->getModel( 'bill' );

		$tax     = JRequest::getFloat( 'tax', 0 );

		$bill_id = JRequest::getInt( 'bill' );

		$bill = & JTable::getInstance( 'bill', 'Table' );

		$bill->load( $bill_id );

		$params = new JParameter( $bill->params );

		if( JRequest::getVar( "return_success" ) ) {
			$params->set( "return_success", base64_decode( JRequest::getVar( "return_success" ) ) );
		}

		if( JRequest::getVar( "return_fail" ) ) {
			$params->set( "return_fail", base64_decode( JRequest::getVar( "return_fail" ) ) );
		}

		$params->set( 'tax', JRequest::getFloat( 'newtax',  $params->get( 'tax' ) ) );

		$use_tax = true;
		$countries = $params->get('tax_countries');
		if($countries && BILL_CUS_COUNTRY != -1)
		{
			$user_country =  $model->getField( $user->get( 'id' ), constant( "BILL_CUS_COUNTRY" ) );
			if(!is_array($countries)) settype($countries, 'array');
			if(in_array($user_country, $countries))
			{
				$use_tax = false;
				$tax = 1;
			}

		}
		$params->set( "tax_use", $tax );



		$items = unserialize( $bill->product_list );

		$total = 0;
		foreach ( $items as $i => $item ) {
			if($item['title'] == '') continue;
			$amount_item = JRequest::getVar( 'amount'.$i,  $item['amount'] );
			$qnt_item    = JRequest::getVar( 'qnt'.$i,     $item['qnt'] );
			$item_tax    = JRequest::getVar( 'newtax_'.$i, $item['item_tax'] !== "" ? $item['item_tax'] :  $params->get( 'tax', 0 ) );

			$products[$i]['title']  = $item['title'].' '.JRequest::getString('description'.$i);
			$products[$i]['amount'] = $amount_item;
			$products[$i]['qnt']    = $qnt_item;

			if( !$tax && $use_tax) {
				$products[$i]['tax_procent'] = $item_tax;
				$products[$i]['tax']         = ( ( $amount_item * $qnt_item ) / 100 ) * $item_tax;
				$products[$i]['tax_name']    = $item['item_tax_name'] !== "" ? $item['item_tax_name'] :  $params->get( 'tax_name' );

				$total += $amount_item * $qnt_item + $products[$i]['tax'];
			} else {
				$total += $amount_item * $qnt_item;
			}

			$title[] = $item['title'].' '.JRequest::getString('description'.$i);
		}


		if( $total <= 0 ) {
			JError::raiseWarning( 500, 'Bill amount is 0.00' );
			parent::display();
			return;
		}

		$total = number_format( $total, 2, '.', '' );

		$i_row =& JTable::getInstance('invoice', 'Table');

		$params->def('tax_id', JRequest::getVar('taxID',''));
		$params->def('client_comment', JRequest::getVar('client_comment',''));

		$array_key = array('name','address','city','state','zip','country','tel' );
		foreach ($array_key as $val) {
			if( $params->get( "bill_as_text" ) ) {
				$association = ( $val == "name" ? $user->get( 'name' ) : $model->getField( $user->get( 'id' ), constant( "BILL_CUS_".strtoupper( $val ) ) ) );
				$params->set( $val, $params->get( $val, $association ) );
			} else {
				$params->def($val, JRequest::getVar($val));
			}
			if( $params->get( "ship_as_text" ) ) {
				$association = ( $val == "name" ? $user->get( 'name' ) : $model->getField( $user->get( 'id' ), constant( "BILL_CUS_".strtoupper( $val ) ) )  );
				$params->set( 'ship_'.$val, $params->get( 'ship_'.$val, $association ) );
			} else {
				$params->def( 'ship_'.$val, JRequest::getVar('ship_'.$val));
			}

		}

		if( !$params->get( 'userEmail_as_text' ) ) {
			$params->def( 'userEmail', JRequest::getVar( 'userEmail' ) );
		}

		$user_tmp_email = $user->get( 'email' );

		if( !$user->get('id') ) {
			$email = $params->get( 'userEmail_as_text' ) ? $params->get( 'userEmail' ) : JRequest::getVar( 'userEmail' ) ;
			if( !JMailHelper::isEmailAddress( $email ) ) {

				JError::raiseWarning(500, JText::_( 'Email address isn`t valid' ). $db->getErrorMsg());
				parent::display();
				return;
			} else {
				$user_tmp_email = $email;
			}
		}

		$check_array["bill"] = array(
		array( 'billto_name',    BILL_BILLTO_NAME,    'name',         'Field Name (Bill to) is required' ),
		array( 'billto_address', BILL_BILLTO_ADDRESS, 'address',      'Field Address (Bill to) is required' ),
		array( 'billto_city',    BILL_BILLTO_CITY,    'city',         'Field City (Bill to) is required' ),
		array( 'billto_state',   BILL_BILLTO_STATE,   'state',        'Field State (Bill to) is required' ),
		array( 'billto_zip',     BILL_BILLTO_ZIP,     'zip',          'Field Zip (Bill to) is required' ) ,
		array( 'billto_country', BILL_BILLTO_COUNTRY, 'country',      'Field Country (Bill to) is required' ),
		array( 'billto_tel',     BILL_BILLTO_TEL,     'tel',          'Field Telephone (Bill to) is required' )
		);

		$check_array["ship"] = array(

		array( 'shipto_name',    BILL_SHIPTO_NAME,    'ship_name',    'Field Name (Ship to) is required' ),
		array( 'shipto_address', BILL_SHIPTO_ADDRESS, 'ship_address', 'Field Address (Ship to) is required' ),
		array( 'shipto_city',    BILL_SHIPTO_CITY,    'ship_city',    'Field City (Ship to) is required' ),
		array( 'shipto_state',   BILL_SHIPTO_STATE,   'ship_state',   'Field State (Ship to) is required' ),
		array( 'shipto_zip',     BILL_SHIPTO_ZIP,     'ship_zip',     'Field Zip (Ship to) is required'),
		array( 'shipto_country', BILL_SHIPTO_COUNTRY, 'ship_country', 'Field Country (Ship to) is required' ),
		array( 'shipto_tel',     BILL_SHIPTO_TEL,     'ship_tel',     'Field Telephone (Ship to) is required' )
		);

		foreach( $check_array as $gkey => $group_param ) {
			if( $gkey == "bill" && $params->get( "bill_as_text" ) ) continue;
			if( $gkey == "ship" && $params->get( "ship_as_text" ) ) continue;
			foreach( $group_param as $param ) {
				if( $params->get( $param[0], $param[1] ) == 'req' && !JRequest::getVar( $param[2] ) ) {

					JError::raiseWarning(500, JText::_('Some required information is empty '). JText::_( $param[3] ) );
					parent::display();
					return;
				}
			}
		}

		$i_attributes = array(
			'user_id'      => $user->get('id'),
			'access'       => $user->get('aid'),
			'ctime'        => /*$bill->ctime*/$datenow->toFormat("%Y-%m-%d-%H-%M-%S"),
			'bill_id'      => JRequest::getVar('bill'),
			'seller_id'    => $bill->seller_id,
			'total'        => $total,
			'client'       => $bill->client,
			'client_id'    => $bill->client_id,
			'coption'      => $bill->coption,
			'order_num'    => $bill->order_num,
			'product_list' => serialize($products),
			'name'         => $title[0],
			'params'       => $params->toString()
		);

			
		if( !$i_row->bind( $i_attributes ) ) {
			JError::raiseWarning(500, JText::_('Cannot Check'). $i_row->getError() );
			parent::display();
			return;
		}

		if (!$i_row->check()) {
			JError::raiseWarning(500, JText::_('Cannot Check'). $i_row->getError());
			parent::display();
			return;
		}

		if (!$i_row->store()) {
			JError::raiseWarning(500, JText::_('Cannot Store'). $i_row->getError());
			parent::display();
			return;
		}
		if( !$user->get( 'id' ) ) {
			$this->storeSessAndCookInv( $i_row->id );
		}

		$param['processor']      = JRequest::getVar('processor');
		$param['order_id']       = $i_row->id;
		$param['order_title']    = $title[0];//mplode( ', ', $title );
		$param['order_quantity'] = count($items);
		$param['user_id']        = $user->get( 'id' );
		$param['email']          = $user_tmp_email;
		$param['prod_id']        = $i_row->id;
		$param['bill_id']        = $bill->id;
		$param['view']           = 'bill';
		$param['params']         = $params->toString();
		$param['task']           = 'create';
		$param['layout']         = 'history';
		$param['bill_id']        = JRequest::getVar( 'bill_id' );
		$param['order_amount']   = $total;
		$param['Itemid']         = JRequest::getVar( 'Itemid' );

		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin( 'bill_gateways' );
		$dispatcher->trigger( 'onSendPayment', array ( &$param ) );

		parent::display();
	}

	function storeSessAndCookInv( $id )
	{
		$session = JFactory::getSession();

		//store in cookies
		$inv = array( 0 );

		if( isset( $_COOKIE['my_jsbill_invoices'] ) && $_COOKIE['my_jsbill_invoices'] ) {
			$inv = explode( ',', $_COOKIE['my_jsbill_invoices'] );
		}

		$inv[] = $id;

		setcookie( 'my_jsbill_invoices', implode( ',', $inv ) );

		//store in session
		$inv = $session->get( 'my_jsbill_invoices', array() );

		$inv[] = $id;
		$session->set( 'my_jsbill_invoices', $inv );
	}

	function invoice()
	{

		JRequest::setVar('view', 'invoice' );
		if( !JRequest::getVar( 'layout' ) ) {
			JRequest::setVar('layout', 'default' );
		}
		parent::display();
	}

	function create()
	{
		global $mainframe;
		$db = & JFactory::getDBO();

		$post = JRequest::get('request');

		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin( 'bill_gateways', $post['processor'] );
		$result = $dispatcher->trigger( 'onReceivePayment', array( &$post ) );

		$result = $result[0];

		if( is_array( $result ) ) {
			
			$invoice = & JTable::getInstance( 'invoice', 'Table' );
			$invoice->load( $result["sid"] );
				
			if( !$result['gateway'] || !$result['gateway_id'] || !array_key_exists( 'price', $result ) || !$result['pay'] ) {
				$link = 'index.php?option=com_jsbill&view=bill&Itemid='.JRequest::getInt( 'Itemid' );
				$mainframe->enqueueMessage( JText::_('Not All Information is Passed to bill activated') );
				$mainframe->redirect( $link );
				return ;
			}

			if( strtoupper( md5( Bill::getSecretWord().$result['user_id'].$result['gateway_id'].$result['price'].$result["sid"] ) ) != $result['key'] ) {
				JError::raiseWarning( 500, JText::_('Cannot authorise transaction' ));
				return ;
			}

			$model = $this->getModel('bill');
			$params = new JParameter($invoice->params);
			$date = new JDate();
			$msg = '';

			$result['pay'] = str_replace(array('?'), '', $result['pay']);

			if($result['pay'] == 'fail')
			{
				JError::raiseWarning( 500, JText::_('Tranaction failed'));
				return ;
			}
			if( $result['pay'] == 'success' ) {
				$invoice->published = 1;
				$invoice->inv_num = $model->getNextNum( $invoice );
				$msg = JText::_( 'You have successfully purchased the bill' );
			}
			if($result['pay'] == 'offline')
			{
				$msg = JText::_( 'You have successfully purchased the bill but not activated automaticaly.' );
			}

			$invoice->gateway    = $result['gateway'];
			$invoice->gateway_id = $result['gateway_id'];
			$invoice->ptime      = $date->toFormat();

			$mainframe->enqueueMessage( $msg );

			if( $invoice->store( ) ) 
			{
				$dispatcher =& JDispatcher::getInstance();
				JPluginHelper::importPlugin('bill');
				$dispatcher->trigger('onSuccessPayment',array(& $result, &$invoice));

				$bill = JTable::getInstance('Bill', 'Table');
				$bill->load( $invoice->bill_id );
				$bill->used_num  = (int)$bill->used_num + 1;
				$bill->store();

				$this->sendMailAlerts( $result, $invoice, $bill );

				/*if( $params->get( "external_return" ) ) {
				 $link = base64_decode( $params->get( "external_return" ) );
				 $return_uri = JFactory::getURI( $link );
				 $return_uri->setVar( "result_pay", $invoice->published ? "success" : "fail" );
				 $products = unserialize( $invoice->product_list );
				 foreach( $products as $product ) {
				 $net_price += $product[ "amount" ] * $product[ "qnt" ];
				 }
				 $return_uri->setVar( "net_price",  $net_price );

				 $mainframe->redirect( $return_uri->toString() );
				 exit;
				 }*/

				if( $invoice->published ) {
					$link = 'index.php?option=com_jsbill&task=invoice&id='.$invoice->id.'&Itemid='.JRequest::getInt('Itemid', BILL_INV_ITEMID);

					if( $params->def( 'return_success' ) ) {
						$link = urldecode($params->def('return_success'));
						if(!strpos('?', $link)) $link .= '?';
						$req = '';

						foreach ($_POST as $key => $value) {
							if($key == 'view' || $key == 'layout' || $key == 'option' || $key == 'task' || $key == 'processor') continue;
							$value = urlencode(stripslashes($value));
							$req .= "&$key=$value";
						}

						foreach ($result as $key => $value) {
							if($key == 'view' || $key == 'layout' || $key == 'option' || $key == 'task' || $key == 'processor') continue;
							$value = urlencode(stripslashes($value));
							$req .= "&result_$key=$value";
						}

						$products = unserialize( $invoice->product_list );
						foreach( $products as $product ) {
							$net_price += $product[ "amount" ] * $product[ "qnt" ];
						}

						$value = urlencode(stripslashes($net_price));

						$req .= "&result_net_price=$value";

						$req .= "&result_invoice_id=$invoice->id";

						header("Location: {$link}{$req}", TRUE, 307);
						exit;
					}
				} 
				else {
					$link = 'index.php?option=com_jsbill&view=bill&layout=history&Itemid='.JRequest::getInt('Itemid', BILL_INV_ITEMID);
					if( $params->def('return_fail') ) {
						$link = urldecode( $params->def( 'return_fail' ) );
						if( !strpos('?', $link ) ) $link .= '?';
						$req = '';

						foreach ($_POST as $key => $value) {
							if($key == 'view' || $key == 'layout' || $key == 'option' || $key == 'task' || $key == 'processor') continue;
							$value = urlencode(stripslashes($value));
							$req .= "&$key=$value";
						}

						foreach ($result as $key => $value) {
							if($key == 'view' || $key == 'layout' || $key == 'option' || $key == 'task' || $key == 'processor') continue;
							$value = urlencode(stripslashes($value));
							$req .= "&result_$key=$value";
						}

						$products = unserialize( $invoice->product_list );
						foreach( $products as $product ) {
							$net_price += $product[ "amount" ] * $product[ "qnt" ];
						}

						$value = urlencode(stripslashes($net_price));
						$req .= "&result_net_price=$value";

						$req .= "&result_invoice_id=$invoice->id";

						header("Location: {$link}{$req}", TRUE, 307);
						exit;
					}
				}

				$mainframe->redirect($link);
			} else {
				$dispatcher =& JDispatcher::getInstance();
				JPluginHelper::importPlugin('bill');
				$dispatcher->trigger('onFaildPayment',array(& $result, &$invoice));

				JError::raiseWarning( 405, JText::_( 'Cannot Store result' ) );
				$link = 'index.php?option=com_jsbill&view=bill&layout=history&Itemid='.JRequest::getInt('Itemid', BILL_INV_ITEMID);

				$mainframe->redirect($link);
			}
		} else {
			JError::raiseWarning( 405, JText::_( 'Cannot Get plugin result' ) );
		}

		parent::display();
	}

	/* This function calls after Receive Payment */
	function sendMailAlerts( $post, & $invoice, & $bill )
	{
		global $mainframe;

		$user        = JFactory::getUser( $post['user_id'] );
		$config      = JFactory::getConfig();
		$params      = new JParameter( $invoice->get( "params" ) );
		$bill_params = new JParameter( $bill->get( "params" ) );
		$products    = unserialize( $invoice->get( "product_list" ) );

		$byer_mail   = $params->get( 'userEmail', $user->get('email' ) );
		$byer_name   = $params->get( 'name', $user->get('name') );

		if( $bill->get( "seller_id" ) ) {
			$seller      = JFactory::getUser( $bill->get( "seller_id" ) );
		}

		$seller_name = isset( $seller ) ? $seller->get( "name" ) : "";
		$seller_mail = isset( $seller ) ? $seller->get( "email" ) : "";

		/*
		 send alert to byer
		 */

		$post['pay'] = str_replace(array('?'), '', $post['pay']);
		//$post['pay'] = 'success';
		if( $post['pay'] == 'success' ) {
			$body = JText::_('BILL_SUCCESS_EMAIL');
			$subject = sprintf(JText::_('Your Bill paid successfuly'));
		} else {
			$body = JText::_('BILL_FAIL_EMAIL');
			$subject = sprintf(JText::_('Your Bill paid but not activated'));
		}

		$invoice_url = JURI::root().'index.php?option=com_jsbill&task=invoice&id='.$invoice->id.'&Itemid='.$bill_params->get( 'byer_alert_itemid', JRequest::getInt( 'Itemid' ) );

		$body = str_replace( '[USER]',        $user->get( 'name' ),             $body );
		//$body = str_replace( '[FIRST_NAME]',  $user->get( 'name' ),             $body );
		$body = str_replace( '[SITE_NAME]',   $mainframe->getCfg( 'sitename' ), $body );
		$body = str_replace( '[SITE_URL]',    JURI::root(),  $body );
		$body = str_replace( '[ORDER_ID]',    $post['gateway_id'],              $body );
		$body = str_replace( '[INVOICE_URL]', $invoice_url,                     $body );

		jimport( 'joomla.mail.mail' );

		$email_send = $user->id ? $user->get('email') : $post['email'];

		$mailfrom = $config->getValue('config.mailfrom');
		$fromname = $config->getValue('config.fromname');

		$result = JUtility::sendMail( $mailfrom, $fromname, array( $email_send ), JMailHelper::cleanSubject($subject), JMailHelper::cleanBody($body) );

		if( !$result ) {
			JError::raiseWarning( 200, 'Error to send user alert' );
		}


		if( $post['pay'] == 'success' ) {
			/*
			 send alert to administrator and to additional mails
			 */

			$body = JText::_( "BILL_ADMIN_ALERT");
			$body = str_replace('[USER]', $byer_name, $body);
			$body = str_replace('[EMAIL]', $byer_mail, $body);
			$body = str_replace('[SELLER]', $seller_name, $body);
			$body = str_replace('[SELLER_EMAIL]', $seller_mail, $body);
			$body = str_replace('[BILL_NAME]', $products[1]['title'], $body);
			$body = str_replace('[SITE_NAME]', $config->getValue( 'config.sitename' ), $body);
			$body = str_replace('[SITE_URL]', JURI::root(), $body);
			$body = str_replace('[ORDER_ID]', $post['gateway_id'], $body);

			$subject = str_replace('[SITE_NAME]',  $config->getValue( 'config.sitename' ), JText::_( "Bill was paid on the [SITE_NAME]") );

			$emails = $bill_params->get( "mails_alert" );

			$addresses = array();

			$emails = explode( "\n", str_replace( "\r", "", $emails ) );
			foreach( $emails as $email ) {
				if( !$email ) continue;
				$addresses[] = trim( $email );
			}

			if( $bill_params->get( "super_alert" ) ) {
				$addresses[] = $config->getValue('config.mailfrom');
			}

			if( count( $addresses ) ) {
				$mail_result = JUtility::sendMail( $mailfrom, $fromname, $addresses, JMailHelper::cleanSubject( $subject ), JMailHelper::cleanBody( $body ) );
				if( !$mail_result ) {
					JError::raiseWarning( 200, 'Error to send admin alert' );
				}
			}

			if( $bill_params->get( "owner_alert" ) && isset( $seller ) ) {
				/*
				 send alert to bill owner
				 */
					
				$subject = str_replace('[SITE_NAME]', $config->getValue( 'config.sitename' ) , JText::_( "Your bill was paid on the [SITE_NAME]") );

				$myselings_link = JURI::root().'index.php?option=com_jsbill&view=mysellings&Itemid='.$bill_params->get( 'seller_alert_itemid', JRequest::getInt( 'Itemid' ) );

				$body = JText::_( "BILL_OWNER_ALERT");
				$body = str_replace('[OWNER]', $seller->name, $body);
				$body = str_replace('[BILL_NAME]', $products[1]['title'], $body);
				$body = str_replace('[SITE_NAME]', $config->getValue( 'config.sitename' ), $body);
				$body = str_replace('[SITE_URL]', JURI::root(), $body);
				$body = str_replace('[USER]', $byer_name, $body);
				$body = str_replace('[EMAIL]', $byer_mail, $body);
				$body = str_replace('[ORDER_ID]', $post['gateway_id'], $body);
				$body = str_replace('[LINK]', $myselings_link, $body );

				$email = $seller->get( "email" );
					
				$mail_result = JUtility::sendMail( $mailfrom, $fromname, array( $email ), JMailHelper::cleanSubject( $subject ), JMailHelper::cleanBody( $body ) );

				if( !$mail_result ) {
					JError::raiseWarning( 200, 'Error to send bill owner alert' );
				}
			}
		}
	}
}
?>