<?php
/**
 * $Id: bill.php 7579 2011-12-02 07:45:55Z alfiya $
 * $LastChangedDate: 2011-12-02 13:45:55 +0600 (Fri, 02 Dec 2011) $
 * $LastChangedBy: alfiya $
 * MightyInvoice by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
class BillModelBill extends JModel
{
	var $_history = null;
	var $_bill = null;
	var $_processor = null;
	var $_def = 1;
	var $transaction_id =0;
	var $_totalSellings = 0;
	var $_sellings = null;

	function __construct()
	{
		global $mainframe, $option;

		parent::__construct();

		$this->setState( 'limit', $mainframe->getUserStateFromRequest( $option.'.limit', 'limit', "20", 'int' ) );
		if( JRequest::getInt( 'limit', 0 ) ) {
			$this->setState( 'limitstart', 0 );
		} else {
			$this->setState( 'limitstart', JRequest::getInt( 'limitstart', 0 ) );
		}

	}

	function getField( $user_id, $field_id )
	{
		$sql = " SELECT fvalue"
		."\n   FROM #__juser_extended_data"
		."\n  WHERE user_id = ".$user_id." AND field_id = ".$field_id;
		$this->_db->setQuery( $sql );
		return $this->_db->loadResult();
	}

	function getInvoicesCount( $user_id, $bill_id )
	{
		$sql = "SELECT COUNT(*) FROM #__bills_invoice WHERE user_id = '{$user_id}' AND bill_id = '{$bill_id}' AND gateway_id > 0 AND gateway != ''";
		$this->_db->setQuery( $sql );
		return $this->_db->loadResult();
	}

	function getInvoice($id, $where='')
	{

		$user   = & JFactory::getUser();
		$where = "AND user_id = ".$user->get('id').' '.$where;

		$sql = "SELECT * , LPAD( `inv_num`, ".BILL_INV_DIG.", 0 ) AS inv_num,
		DATE_FORMAT(ctime,'%e %M %Y') as format_ctime
		FROM #__bills_invoice
		WHERE id = $id ".$where;

		$this->_db->setQuery($sql);

		$row = $this->_db->loadObject();

		JRequest::setVar('bill', @$row->bill_id);
		return $row;
	}
	function getVar($var,$def)
	{
		if(isset($var)){return $var;}
		elseif($this->_def) {return $def;}
		else {return null;}
	}
	function getVarItem($param,$def=null)
	{
		$var = array();
		if(isset($param))
		{
			if(is_array($param))
			{
				foreach ($param as $item)
				$var[] = $item;
			}
			else
			{
				$var[] = $param;
			}
			return serialize($var);
		}
		else return serialize($def);
	}
	function getPayments()
	{
		$sql = "SELECT element, params  FROM #__plugins WHERE folder = 'bill_gateways' AND published = 1";
		return $this->_getList($sql);
	}

	function createBill()
	{
		global $mainframe;

		$param = new JParameter('');
		
		$row = JTable::getInstance('bill', 'Table');

		$param->set( 'tax',        JRequest::getFloat( 'tax',           BILL_TAX ) );
		$param->set( 'tax_name',   JRequest::getVar(   'tax_name',      BILL_TAX_NAME ) );
		$param->set( 'show_personal_taxid',   JRequest::getVar(   'show_personal_taxid',      BILL_SHOW_PERSONAL_TAXID ) );
		$param->set( 'tax_chose',  JRequest::getInt(   'tax_chose',     BILL_TAX_CHOSE ) );
		$param->set( 'tax_change', JRequest::getInt(   'tax_change',    BILL_TAX_CHANGE ) );
		$param->set( 'price',      JRequest::getVar(   'price_formats', BILL_PRICE ) );
		$param->set( 'curr',       JRequest::getVar(   'currency',      BILL_CURR ) );
		$param->set( 'inv_logo',   JRequest::getVar(   'logo',          BILL_INV_LOGO ) );

		$param->set( 'billto_name',    JRequest::getVar( 'billto_name',    BILL_BILLTO_NAME ) );
		$param->set( 'billto_address', JRequest::getVar( 'billto_address', BILL_BILLTO_ADDRESS ) );
		$param->set( 'billto_city',    JRequest::getVar( 'billto_city',    BILL_BILLTO_CITY ) );
		$param->set( 'billto_state',   JRequest::getVar( 'billto_state',   BILL_BILLTO_STATE ) );
		$param->set( 'billto_zip',     JRequest::getVar( 'billto_zip',     BILL_BILLTO_ZIP ) );
		$param->set( 'billto_country', JRequest::getVar( 'billto_country', BILL_BILLTO_COUNTRY ) );
		$param->set( 'billto_tel',     JRequest::getVar( 'billto_tel',     BILL_BILLTO_TEL ) );

		$param->set( 'shipto_name',    JRequest::getVar( 'shipto_name',    BILL_SHIPTO_NAME ) );
		$param->set( 'shipto_address', JRequest::getVar( 'shipto_address', BILL_SHIPTO_ADDRESS ) );
		$param->set( 'shipto_city',    JRequest::getVar( 'shipto_city',    BILL_SHIPTO_CITY ) );
		$param->set( 'shipto_state',   JRequest::getVar( 'shipto_state',   BILL_SHIPTO_STATE ) );
		$param->set( 'shipto_zip',     JRequest::getVar( 'shipto_zip',     BILL_SHIPTO_ZIP ) );
		$param->set( 'shipto_country', JRequest::getVar( 'shipto_country', BILL_SHIPTO_COUNTRY ) );
		$param->set( 'shipto_tel',     JRequest::getVar( 'shipto_tel',     BILL_SHIPTO_TEL ) );
		
		$param->set( 'show_district',     JRequest::getVar( 'show_district',     0 ) );
				
		$address_bill = JRequest::getVar( 'address_bill', array() );
		$address_ship = JRequest::getVar( 'address_ship', array() );

		if( count( $address_bill ) ) {
			if( isset( $address_bill[ 'bill_name' ] ) )    $param->set( 'name',    $address_bill[ 'bill_name' ] );
			if( isset( $address_bill[ 'bill_address' ] ) ) $param->set( 'address', $address_bill[ 'bill_address' ] );
			if( isset( $address_bill[ 'bill_city' ] ) )    $param->set( 'city',    $address_bill[ 'bill_city' ] );
			if( isset( $address_bill[ 'bill_state' ] ) )   $param->set( 'state',   $address_bill[ 'bill_state' ] );
			if( isset( $address_bill[ 'bill_zip' ] ) )     $param->set( 'zip',     $address_bill[ 'bill_zip' ] );
			if( isset( $address_bill[ 'bill_country' ] ) ) $param->set( 'country', $address_bill[ 'bill_country' ] );
			if( isset( $address_bill[ 'bill_tel' ] ) )     $param->set( 'tel',     $address_bill[ 'bill_tel' ] );

			if( isset( $address_bill[ 'as_text' ] ) )      $param->set( 'bill_as_text', $address_bill[ 'as_text' ] );
		}

		if( JRequest::getVar( 'userEmail_as_text', 0 ) && JRequest::getVar( 'userEmail', "" ) ) {
			$param->set( 'userEmail_as_text', 1 );
		}
		if( JRequest::getVar( 'userEmail', "" ) ) {
			$param->set( 'userEmail', JRequest::getVar( 'userEmail' ) );
		}

		if( count( $address_ship ) ) {
			if( isset( $address_ship[ 'ship_name' ] ) )    $param->set( 'ship_name',    $address_ship[ 'ship_name' ] );
			if( isset( $address_ship[ 'ship_address' ] ) ) $param->set( 'ship_address', $address_ship[ 'ship_address' ] );
			if( isset( $address_ship[ 'ship_city' ] ) )    $param->set( 'ship_city',    $address_ship[ 'ship_city' ] );
			if( isset( $address_ship[ 'ship_state' ] ) )   $param->set( 'ship_state',   $address_ship[ 'ship_state' ] );
			if( isset( $address_ship[ 'ship_zip' ] ) )     $param->set( 'ship_zip',     $address_ship[ 'ship_zip' ] );
			if( isset( $address_ship[ 'ship_country' ] ) ) $param->set( 'ship_country', $address_ship[ 'ship_country' ] );
			if( isset( $address_ship[ 'ship_tel' ] ) )     $param->set( 'ship_tel',     $address_ship[ 'ship_tel' ] );

			if( isset( $address_ship[ 'as_text' ] ) )      $param->set( 'ship_as_text', $address_ship[ 'as_text' ] );
		}

		if( JRequest::getVar( 'return_success' ) ) {
			$param->set( 'return_success', base64_decode( JRequest::getVar('return_success' ) ) );
		}

		if( JRequest::getVar( 'return_fail' ) ) {
			$param->set( 'return_fail', base64_decode( JRequest::getVar( 'return_fail' ) ) );
		}
		$processor = JRequest::getVar( 'processors', array() );

		foreach ( $processor AS $key => $val ) {
			$param->set($key, $val);
		}
		/*
		 $payments = $this->getPayments();
		 if(!is_array($payments)) $payments = array();
		 foreach($payments AS $payment)
		 {
		 $param->def($payment.'_enable', 1);
		 }
		 */

		$seller = JRequest::getVar( 'seller', array());

		foreach ($seller AS $key => $val) {
			$param->set($key, $val);
		}

		$row->params = $param->toString();

		$products = array();
		$i = 0;
		for($j = 1; $j < 1000; $j++) {
			$item_title  = JRequest::getString( 'item_title'.$j,  '' );
			$item_amount = JRequest::getString( 'item_amount'.$j, '' );

			if( !$item_title || !$item_amount ) continue; 
			
			$i++;
			$products[$i]['title']       = $item_title;
			$products[$i]['amount']      = $item_amount;
			$products[$i]['qnt']         = JRequest::getString('item_qnt'.$j, 1);
			$products[$i]['chng_price']  = JRequest::getString('item_amount_change'.$j, 0);
			$products[$i]['chng_qnt']    = JRequest::getString('item_qnt_change'.$j, 0);
			$products[$i]['description'] = JRequest::getString('description'.$j, 0);

			$products[$i]['item_tax']      = JRequest::getString('item_tax'.$j, "" );
			$products[$i]['item_tax_name'] = JRequest::getString('item_tax_name'.$j, "" );
			$products[$i]['chng_item_tax'] = JRequest::getString('chng_item_tax'.$j, "" );
		}

		if( count( $products ) <= 0 ) {
			$this->setError( 'Not all product listed' );
			return false;
		}

		$row->product_list = serialize( $products );

		$row->order_num = JRequest::getVar( 'order_number' );
		$row->access    = JRequest::getVar( 'access',   0 );
		$row->user_id   = JRequest::getVar( 'to_user',  0 );
		$row->use_user  = JRequest::getVar( 'use_user', 0 );
		$row->use_num   = JRequest::getVar( 'use_num',  0 );
		$row->extime    = JRequest::getVar( 'extime',   '0000-00-00 00:00:00' );
		$row->visible   = 0;
		$row->client    = JRequest::getVar( 'client',   'Mighty Invoice' );
		$row->coption   = JRequest::getVar( 'coption',  'com_jsbill' );
		$row->client_id = JRequest::getVar( 'client_id', JRequest::getInt( 'bill' ) );
		$row->seller_id = JRequest::getVar( 'seller_id' );

		if( !$row->order_num ) {
			$this->setError( 'Order number is not set' );
			return false;
		}

		if( !$row->client || !$row->coption ) {
			$this->setError( 'Client not set' );
			return false;
		}

		/*$select  = " SELECT id"
		 ."\n   FROM #__bills"
		 ."\n  WHERE order_num = '{$row->order_num}'"
		 ." AND coption = '{$row->coption}'"
		 ." AND client = '{$row->client}'"
		 ." AND seller_id = '{$row->seller_id}'"
		 ." AND client_id = '{$row->client_id}'"
		 ;

		 $this->_db->setQuery( $select );

		 $exists = $this->_db->loadResult();*/
		$fields = JRequest::getVar( "fields", array() );

		$url_fields = "";
		foreach( $fields as $key => $field ) {
			$url_fields .= "&".$key."=".urlencode( $field );
		}

		/*if( $exists ) {
			$mainframe->redirect( 'index.php?option=com_jsbill&view=bill&bill='.$exists.$url_fields.'&Itemid='.JRequest::getInt( 'Itemid' ) );
			return;
			}*/
		if ( !$row->check() ) {
			$this->setError( 'Check fail'. $row->_error );
			return false;
		}
		
		if ( !$row->store() ) {
			$this->setError( 'Cannot Store'. $row->getError() );
			return false;
		}
		$msg = '';
		if(count($products) < $i)
		$msg = JText::_('Not all products were passed to bill' );

		$mainframe->redirect('index.php?option=com_jsbill&view=bill&bill='.$row->id.$url_fields.'&Itemid='.JRequest::getInt('Itemid'), $msg);
	}

	function getBill()
	{
		global $mainframe;

		$id = JRequest::getInt('bill');
		$user = &JFactory::getUser();

		if( !$id ) {
			$this->createBill();
			return ;
		}

		$sql = "SELECT * , DATE_FORMAT(ctime,'%e %M %Y') as format_ctime, if(extime > NOW(), 0, 1) as expire, if(ctime > NOW(), 1,0) as start
		FROM #__bills
		WHERE id = '{$id}'";

		$this->_db->setQuery( $sql );
		$row = $this->_db->loadObject();

		return $row;
	}

	function getNextNum( $row )
	{
		$select = "SELECT COUNT(*) FROM #__bills_invoice WHERE published = 1 ";
		//$select .= "AND order_num = '{$row->order_num}'";
		$select .= "AND coption = '{$row->coption}'";
		$select .= "AND client = '{$row->client}'";
		$select .= "AND seller_id = '{$row->seller_id}'";
		$this->_db->setQuery($select);
		$number = $this->_db->loadResult() + 1 + BILL_INV_NUM;
		return sprintf('%0'.BILL_INV_DIG.'d', $number);
	}

	function getHistory()
	{
		global $mainframe;
		if (empty($this->_history))
		{
			$user =& JFactory::getUser();
			$userEmail = JString::strtolower( JRequest::getVar( "userEmail", "" ) );

			if( !$user->get('id') && !$userEmail ) return array();

			$query = $this->_buildQueryHistory();
			$this->_history = $this->_getList($query);

			if( !$user->get('id') && $userEmail && ! count( $this->_history ) ) {
				$mainframe->enqueueMessage( JText::_('There is no public Bill purchased with this email.' ));
			}
		}

		return $this->_history;
	}

	function _buildQueryHistory()
	{
		global $mainframe;
		$user =& JFactory::getUser();

		$option = JRequest::getVar('option');
		$context          = "$option.view_history";
		$filter_order     = $mainframe->getUserStateFromRequest( "$context.filter_order", 	'filter_order',  'id' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( "$context.filter_order_Dir",	'filter_order_Dir',	'DESC' );


		if ( $user->get('id') ) {
			$where = " user_id = ".$user->get('id');
		} else {
			$inv       = $this->getInvoicesFromSessAndCook();
			$userEmail = JString::strtolower( JRequest::getVar( "userEmail", "" ) );

			$where = ' id IN ('.implode( ',', $inv ).') AND concat( "\n", LOWER( params ) ) LIKE "%\nuseremail='.$userEmail.'\n%"';
		}
		if($filter_order)
		{
			$order_by = ($filter_order) ? "ORDER BY $filter_order $filter_order_Dir" : "\n ORDER BY ptime DESC";
		}


		$query = "   SELECT *, LPAD( `inv_num`, ".BILL_INV_DIG.", 0 ) AS inv_num "
		."\n     FROM #__bills_invoice"
		."\n    WHERE ( ".$where." ) AND gateway_id != ''"
		.$order_by;

		return $query;
	}

	function getInvoicesFromSessAndCook()
	{
		$session = JFactory::getSession();

		$inv =  array();
		if( isset( $_COOKIE['my_jsbill_invoices'] ) && $_COOKIE['my_jsbill_invoices'] ) {
			$inv = explode( ',', $_COOKIE['my_jsbill_invoices'] );
		}

		$inv = array_merge( $inv, $session->get( 'my_jsbill_invoices', array() ) );

		$inv = array_unique ( $inv );
		return $inv;
	}

	function getProcessors()
	{
		if (empty($this->_processor))
		{
			$query = $this->_buildQueryProcessor();
			$this->_processor = $this->_getList($query);
		}
		return $this->_processor;
	}
	function _buildQueryProcessor()
	{
		$sql = "SELECT * FROM #__plugins
                 WHERE `folder` = 'bill_gateways' AND published = 1
              ORDER BY ordering";

		return $sql;
	}

	function getPersonalBills( $user, $post )
	{
		$where[] = "user_id = ".$user->get( 'id' );
		$where[] = "published = 1";
		$where[] = "( extime > NOW() || extime = '0000-00-00 00:00:00' )";
		$where[] = "ctime <= NOW()";

		if( isset( $post['client'] ) ) {
			$where[] = "client = '".$this->_db->getEscaped( $post['client'] )."'";
		}
		if( isset( $post['client_id'] ) ) {
			$where[] = "client_id = '".$this->_db->getEscaped( $post['client_id'] )."'";
		}
		if( isset( $post['seller'] ) ) {
			$where[] = "seller_id = '".$this->_db->getEscaped( $post['seller'] )."'";
		}

		$where = implode( " AND ", $where );

		$sql = " SELECT *, DATE_FORMAT( ctime, '%e %M %Y' ) as format_ctime, if( extime > NOW(), 0, 1 ) as expire, if( ctime > NOW(), 1, 0 ) as start"
		."\n   FROM #__bills"
		."\n  WHERE 1 ".( $where ? " AND " . $where  : "" );

		$this->_db->setQuery( $sql );
		$result = $this->_db->loadObjectList();

		return $result;
	}

	function getSellings( & $user )
	{
		if( empty( $this->_sellings ) ) {
			$query  = $this->_buildQuerySellings( $user );
			$this->_sellings = $this->_getList( $query, $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
		}

		return $this->_sellings;
	}

	function _buildQuerySellings( & $user )
	{
		global $mainframe;
		$option = JRequest::getVar('option');
		$context          = "$option.view_history";
		$filter_order     = $mainframe->getUserStateFromRequest( "$context.filter_order", 	'filter_order',  'id' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( "$context.filter_order_Dir",	'filter_order_Dir',	'DESC' );

		$filter['order'] = $filter_order;
		$filter['order_Dir'] = $filter_order_Dir;

		$where = " seller_id = ".$user->get('id');

		$order_by = $filter_order ? " ORDER BY $filter_order $filter_order_Dir" : "\n  ORDER BY ptime DESC";
		$query = "   SELECT *, LPAD( `inv_num`, ".BILL_INV_DIG.", 0 ) AS inv_num "
		."\n      FROM #__bills_invoice as inv"
		."\n     WHERE ( ".$where." ) AND gateway_id != ''"
		.$order_by;

		return $query;
	}

	function getTotalSellings( & $user )
	{

		if ( !$this->_totalSellings ) {
			$query = $this->_buildQuerySellings( $user );
			$this->_totalSellings = $this->_getListCount( $query );
		}

		return $this->_totalSellings;
	}

	function getPagination( $total )
	{
		if ( empty( $this->_pagination ) ) {
			jimport( 'joomla.html.pagination' );
			$this->_pagination = new JPagination( $total, $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
		}

		return $this->_pagination;
	}
}
?>