<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyInvoice by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();


jimport( 'joomla.application.component.view');
class BillViewBill extends JView
{
	function display($tpl = null)
	{
		global $mainframe;

		if( JRequest::getWord( 'layout' ) == 'history' ) {
			$this->history( $tpl );
			return;
		}

		if( JRequest::getWord( 'layout' ) == 'error_login' ) {
			$this->displayLogin( $tpl );
			return;
		}

		$layout = $this->getLayout();
		$model  = & $this->getModel( 'bill' );
		$user   = & JFactory::getUser();
		$Itemid = JRequest::getInt( 'Itemid' );
		$bill   = $model->getBill();
		$uri    = & JFactory::getURI();

		$title = JText::_('Proforma Invoice');
		$pathway	     = & $mainframe->getPathway();
		$pathway->addItem( $title, '' );

		//if bill is not loaded sending user on error page
		if( !$bill ) {
			$this->displayError('You cannot access this bill', $model->getError(), $tpl);
			return;
		}

		//this is bill params which required the user logination, even if bill access = 0;
		if( $bill->access > 0 || $bill->use_user > 0 ) {
			//if user is not login - redirect him on user login page
			if( !$user->get( 'id' ) ) {
				BillHelper::sendOnLoginPage( '403', JText::_( 'You cannot access this bill. You need to be registered and logged in' ) );
				return;
			}
		}

		//check user access
		if( $bill->access > 0 ) {
			//if user has not enough rights for use bill sending him on error page
			if( $bill->access > $user->get( 'aid' ) ) {
				$this->displayError( 'You cannot access this bill', 'You have not enough rights for use this bill', $tpl );
			}
		}

		//check if bill only for one apointe user and current user is not this user then sending user on error page
		if( $bill->user_id && ( $user->get( 'id' ) != $bill->user_id ) ) {
			$this->displayError( 'You cannot access this bill', 'This bill is not for you', $tpl );
			return;
		}

		//if use of bill limited for each different user
		if( $bill->use_user > 0 ) {
			//if user has maximum number of purchasing then sending him on error page
			$num = $model->getInvoicesCount( $user->get('id'), $bill->id );
			if( $num >= $bill->use_user ) {
				$this->displayError( 'You cannot access this bill', 'The maximum number of purchasing this bill is excided', $tpl );
				return;
			}
		}

		//if maximum number of purchasing this bill is excided
		if( ( $bill->use_num > 0 ) && ( $bill->used_num >= $bill->use_num ) ) {
			$this->displayError( 'You cannot access this bill', 'The maximum number of purchasing this bill is excided', $tpl );
			return;
		}

		//if bill has expired
		if( ( $bill->extime > 0 ) && $bill->expire ) {
			$this->displayError( 'You cannot access this bill', 'This bill have expired', $tpl );
			return;
		}

		$data = new JDate( $bill->ctime );

		//if start time is not mature
		if( $bill->start > 0 ) {
			$this->displayError('You cannot access this bill', 'This bill will be available for purchase on after', $tpl, $data->toFormat( BILL_TIME_FORMAT ) );
			return;
		}

		$items = unserialize( $bill->product_list );

		if( !$bill->order_num || !$items[1]['title'] || count( $items ) <= 0 || !$bill->client || !$bill->coption ) {
			$this->displayError('You cannot access this bill', 'No all required parametrs are set', $tpl);
			return;
		}
		$processors = $model->getProcessors();
		if(!is_array($processors)) $processors = array();
		$uri = JFactory::getURI();
		$params = new JParameter($bill->params);
		$bill->ctime = $data->toFormat(BILL_TIME_FORMAT);

		$params->def('inv_name', BILL_INV_NAME);
		$params->def('inv_logo', BILL_INV_LOGO);

		$l1[] = $params->get( 'inv_address', BILL_INV_ADDRESS );
		$l1[] = $params->get( 'inv_city',    BILL_INV_CITY );
		$l1[] = $params->get( 'inv_state',   BILL_INV_STATE );
		$l1[] = $params->get( 'inv_zip',     BILL_INV_ZIP );
		$l1[] = $params->get( 'inv_country', BILL_INV_COUNTRY );

		$adrress[1] = $l1;

		$l2[JText::_('Telephone')]      = $params->get('inv_tel',    BILL_INV_TEL);
		$l2[JText::_('Fax')]            = $params->get('inv_fax',    BILL_INV_FAX);
		$l2[JText::_('Company Number')] = $params->get('inv_number', BILL_INV_NUMBER);
		$l2[JText::_('Company Tax ID')] = $params->get('inv_tax_id', BILL_INV_TAX_ID);
		$l2[JText::_('Ask for')]        = $params->get('inv_person', BILL_INV_PERSON);

		$adrress[2] = $l2;

		$params->def( 'billto_name',    BILL_BILLTO_NAME );
		$params->def( 'billto_address', BILL_BILLTO_ADDRESS );
		$params->def( 'billto_city',    BILL_BILLTO_CITY );
		$params->def( 'billto_state',   BILL_BILLTO_STATE );
		$params->def( 'billto_zip',     BILL_BILLTO_ZIP );
		$params->def( 'billto_country', BILL_BILLTO_COUNTRY );
		$params->def( 'billto_tel',     BILL_BILLTO_TEL );

		$params->def( 'shipto_name',    BILL_SHIPTO_NAME );
		$params->def( 'shipto_address', BILL_SHIPTO_ADDRESS );
		$params->def( 'shipto_city',    BILL_SHIPTO_CITY );
		$params->def( 'shipto_state',   BILL_SHIPTO_STATE );
		$params->def( 'shipto_zip',     BILL_SHIPTO_ZIP );
		$params->def( 'shipto_country', BILL_SHIPTO_COUNTRY );
		$params->def( 'shipto_tel',     BILL_SHIPTO_TEL );

		$this->assign( 'address',$adrress );

		$params->set( 'tax', JRequest::getFloat( 'newtax', $params->get( 'tax' ) ) );

		$use_tax = true;
		$countries = $params->get('tax_countries');
		if($countries && BILL_CUS_COUNTRY != -1)
		{
			$user_country = $this->getField('country');
			if(!is_array($countries)) settype($countries, 'array');
			if(in_array($user_country, $countries))
			$use_tax = false;
		}

		$now = new JDate( time() );

		$this->assign( 'bill',   $bill );
		$this->assign( 'now',    $now );
		$this->assign( 'items',  $items );
		$this->assign( 'user',   $user );
		$this->assign( 'pay',    $processors );
		$this->assign( 'params', $params );
		$this->assign( 'url',    $uri->toString() );
		$this->assign( 'use_tax',    $use_tax );

		parent::display( $tpl );
	}

	function history( $tpl )
	{
		global $mainframe;
		$user  = JFactory::getUser();
		$uri   = & JFactory::getURI();
		$model = & $this->getModel( 'bill' );
		$items = $model->getHistory();
		$option = JRequest::getVar('option');
		$context          = "$option.view_history";
		$filter_order     = $mainframe->getUserStateFromRequest( "$context.filter_order", 	'filter_order',  'id' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( "$context.filter_order_Dir",	'filter_order_Dir',	'DESC' );

		$filter['order'] = $filter_order;
		$filter['order_Dir'] = $filter_order_Dir;

		$this->setLayout( 'history' );
		$SessAndCookInv = $model->getInvoicesFromSessAndCook();

		$this->assignRef( 'SessAndCookInv', $SessAndCookInv );
		$this->assignRef( 'url',            $uri->toString() );
		$this->assignRef( 'items',          $items );
		$this->assignRef( 'user',           $user );
		$this->assignRef( 'filter',			$filter);

		parent::display($tpl);
	}
	function displayError($title, $msg, $tpl, $add = '')
	{
		$this->setLayout('error');
		$this->assign('title', JText::_($title));
		$this->assign('msg', JText::_($msg).' '.$add);

		parent::display($tpl);
	}

	function displayLogin($tpl)
	{
		$this->assign('title', JText::_('Login'));
		$this->assign('msg', JText::_('You cannot access this bill. You need to be registered and logged in'), 'Error');

		parent::display($tpl);
	}

	function getField( $name )
	{
		if( !JFolder::exists( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_juser' ) ) return '';

		$user = & JFactory::getUser();
		if( !$user->get('id') ) return '';

		$model  = & $this->getModel( 'bill' );

		return $model->getField( $user->get( 'id' ), constant( "BILL_CUS_".strtoupper( $name ) ) );
	}

	function bill_price( $params, $amount )
	{
		return str_replace(array('Sign', '00'), array($params->get('curr', BILL_CURR), number_format($amount,2)), $params->get('price', BILL_PRICE) );
	}

	function renderField( $value, $name, $as_text )
	{
		if( $as_text ) {
			echo $value;
		} else {
			?>
<input
	class="inputbox" type="text" style="width: 100%"
	name="<?php echo $name; ?>" value="<?php echo $value; ?>" />
			<?php
		}
	}

}
?>